#define LOAD_BYTE exx \ ld a,[hl] \ inc hl \ dec b \ exx
#define LOAD_BYTE_2 exx \ ld a,[hl] \ inc hl \ exx
function(DrawGlobe):
	di

	ld	hl,saveSScreen + 12
	ld	de,saveSScreen + 13
	ld	bc,743
	ld	[hl],0
	ldir
	ld	a,96-7
	ld	[clipx],a

	ld	hl,OurWorld@MapData + $4000
	in	a,[7]
	ld	[save7],a
	in	a,[6]
	out	[7],a
	ld	c,a

	ld	de,MAPDATA_COUNT
@PolylineLoop:
	push	de
	ld	b,[hl]
	inc	hl
	exx

	call	@GetCoordinates
	ld	a,h
	add	a,a
	jr	c,@ClipOkay1
	jp	nz,@ClipGroup
	ld	a,l
	sub	47
	jp	nc,@ClipGroup
@ClipOkay1:
	ld	a,d
	add	a,a
	jr	c,@ClipOkay2
	jp	nz,@ClipGroup
	ld	a,e
	sub	31
	jp	nc,@ClipGroup
@ClipOkay2:
	call	@GetCoordinates
	ld	a,h
	rlca
	jr	nc,@ClipOkay3
	inc	a
	jp	nz,@ClipGroup
	ld	a,l
	add	a,47
	jp	nc,@ClipGroup
@ClipOkay3:
	ld	a,d
	rlca
	jr	nc,@ClipOkay4
	inc	a
	jp	nz,@ClipGroup
	ld	a,e
	add	a,31
	jp	nc,@ClipGroup
@ClipOkay4:

	call	@GetCoordinates
	call	@CohenSutherland
	ld	[prevX],hl
	ld	[prevY],de
	ld	[prevCohen],a
	exx
@LineLoopRestore:
	ld	a,[zoomSkip]
	ld	e,a
	exx
	ld	hl,[prevLon]
	ld	de,[prevLat]
@LineLoop:
	LOAD_BYTE
	ld	c,a
	add	a,a
	sbc	a,a
	ld	b,a
	add	hl,bc
	ex	de,hl
	LOAD_BYTE
	ld	c,a
	ex	af,af'
	ld	a,c
	add	a,a
	sbc	a,a
	ld	b,a
	add	hl,bc
	ex	de,hl
	ex	af,af'
	jr	z,@MustShow
	exx
	dec	e
	exx
	jr	nz,@LineLoop
@MustShow:
	ld	[prevLon],hl
	ld	[prevLat],de
	ex	de,hl
	ld	bc,[zoom]
	call	MultBCxDEx2
	push	de
	ld	de,[prevLat]
	ld	bc,[zoom]
	call	MultBCxDEx2
	pop	hl
	call	@CohenSutherland
	ld	[currX],hl
	ld	[currY],de
	ld	[currCohen],a
	or	a
	jp	m,@SkipLine
	ld	b,a
	ld	a,[prevCohen]
	or	a
	jp	m,@SkipLine
	ld	d,l
	exx
	push	bc
	push	de
	push	hl
	ld	b,a
	ld	a,[prevX]
	ld	d,a
	ld	a,[prevY]
	ld	e,a
	call	Drawline
	pop	hl
	pop	de
	pop	bc
	exx
@SkipLine:

	ld	hl,currX
	ld	de,prevX
	ldi \ ldi \ ldi \ ldi \ ldi

	exx
	ld	a,c
	out	[7],a
	ld	a,b
	or	a
	jp	nz,@LineLoopRestore

@CheckHL:
	bit	6,h
	jr	z,@NotBoundary
	res	6,h
	dec	c
	ld	a,c
	out	[7],a
@NotBoundary:
	pop	de
	dec	de
	ld	a,d
	or	e
	jp	nz,@PolylineLoop

;;;;; DrawLabels
	exx
@LabelsLoop:
	in	a,[6]
	sub	5
	out	[7],a

	LOAD_BYTE_2
	ld	[prevCohen],a
	and	31
	jp	z,@LabelsDone
	ex	af,af'
	ld	a,[options]
	rrca
	rrca
	ld	b,a
	LOAD_BYTE_2
	ld	[currCohen],a
	cp	b
	jp	c,@LabelsFixupMore
	and	31
	ld	b,a
	ld	a,[zoomLevel]
	cp	b
	jp	c,@LabelsFixupMore

	LOAD_BYTE_2
	ld	d,a
	LOAD_BYTE_2
	ld	e,a
	ld	hl,[currLon]
	add	hl,de
	ex	de,hl
	ld	bc,[zoom]
	call	MultBCxDEx2
	push	de
	LOAD_BYTE_2
	ld	d,a
	LOAD_BYTE_2
	ld	e,a
	ld	hl,[currLat]
	add	hl,de
	ex	de,hl
	ld	bc,[zoom]
	call	MultBCxDEx2
	pop	hl
	call	@CohenSutherland
	or	a
	jp	nz,@LabelsFixup
	ld	a,l
	sub	80 + 3
	ld	b,a
	ld	a,160 - 3
	sub	e
	ld	c,a

	exx
	ex	af,af'
	ld	b,a
	ld	de,Buffer
	push	de
	call	NameCopy
	exx
	ld	a,[save7]
	out	[7],a

	ld	a,[prevCohen]
	rlca
	rlca
	rlca
	and	7
	cp	4
	jr	c,@LabelNoFix
	inc	a
@LabelNoFix:
	ld	[prevCohen],a
	ld	a,[currCohen]
	add	a,a
	jr	c,@LabelCountry
	ld	hl,Sprites@City
	add	a,a
	ld	[currCohen],a
	jr	nc,@LabelMarker
	ld	hl,Sprites@Capital
@LabelMarker:
	call	PutSprite
	jr	@LabelReady
@LabelCountry:
	add	a,a
	ld	[currCohen],a
	jr	c,@LabelReady
	ld	a,4
	ld	[prevCohen],a
@LabelReady:
	inc	b
	inc	c

	pop	de
	ld	l,7
@GetLabelName:
	ld	a,[de]
	or	a
	jr	z,@GetLabelDone
	cp	','
	jr	nz,@GetLabelNameNotComma
	xor	a
	ld	[de],a
	jr	@GetLabelDone
@GetLabelNameNotComma:
	inc	de
	cp	' '
	jr	nz,@GetLabelName
	ld	a,l
	add	a,6
	ld	l,a
	jr	@GetLabelName
@GetLabelDone:

	ld	ix,Sprites@Horiz
	ld	a,[currCohen]
	add	a,a
	jr	nc,@GetLabelNoSwap
	ld	ix,Sprites@Vert
	ld	a,b
	ld	b,c
	neg
	ld	c,a
@GetLabelNoSwap:
	ld	a,[prevCohen]
	sub	3
	jr	nc,@GetLabelNotTop
	ld	[prevCohen],a
	ld	a,c
	sub	l
	ld	c,a
	jr	@GetLabelNotBottom
@GetLabelNotTop:
	sub	3
	jr	nc,@GetLabelNotMiddle
	ld	[prevCohen],a
	sra	l
	ld	a,c
	add	a,2
	sub	l
	ld	c,a
	jr	@GetLabelNotBottom
@GetLabelNotMiddle:
	sub	3
	ld	[prevCohen],a
	ld	a,c
	add	a,5
	ld	c,a
@GetLabelNotBottom:
	ld	a,c
	sub	6
	ld	c,a
	ld	a,[currCohen]
	add	a,a
	jr	nc,@GetLabelNoNeg
	ld	a,c
	neg
	sub	3
	ld	c,a
@GetLabelNoNeg:

	ld	de,Buffer
	ld	a,b
	ld	[curSel],a
@PutCharNewLine:
	ld	a,c
	add	a,6
	ld	c,a
	ld	a,[currCohen]
	add	a,a
	jr	nc,@PutCharNewLineOkay
	ld	a,c
	sub	12
	ld	c,a
@PutCharNewLineOkay:
	ld	a,[curSel]
	ld	b,a
	ld	a,[prevCohen]
	cp	-1
	jr	z,@PutCharLeft
	push	de
	exx
	ld	c,0
	exx
@PutCharGetWidth:
	ld	a,[de]
	inc	de
	or	a
	jr	z,@PutCharGetWidthDone
	call	PutLabel@ConvChar
	jr	c,@PutCharGetWidthDone
	add	a,Sprites@Widths & 255
	ld	l,a
	adc	a,Sprites@Widths >> 8
	sub	l
	ld	h,a
	ld	a,[hl]
	exx
	add	a,c
	ld	c,a
	exx
	jr	@PutCharGetWidth
@PutCharGetWidthDone:
	pop	de
	exx
	ld	a,[prevCohen]
	cp	-3
	jr	z,@PutCharRight
	sra	c
	dec	c
	dec	c
@PutCharRight:
	ld	a,c
	neg
	exx
	add	a,b
	ld	b,a
	jr	@PutChar
@PutCharLeft:
	ld	a,b
	add	a,5
	ld	b,a

@PutChar:
	ld	a,[de]
	inc	de
	or	a
	jp	z,@LabelsLoop
	call	PutLabel@ConvChar
	jr	c,@PutCharNewLine
	push	de
	push	ix
	pop	hl
	ld	e,a
	ex	af,af'
	ld	a,e
	add	a,a
	add	a,e
	add	a,a
	add	a,e
	ld	d,0
	ld	e,a
	add	hl,de
	add	hl,de
	ld	a,[currCohen]
	add	a,a
	ex	af,af'
	ld	d,a
	ex	af,af'
	jr	nc,@PutCharHoriz
	ld	a,b
	ld	b,c
	ld	c,a
	ld	a,d
	call	PutSprite
	ld	a,b
	ld	b,c
	ld	c,a
	jr	@PutCharVert
@PutCharHoriz:
	ld	a,d
	call	PutSprite
@PutCharVert:

	ex	af,af'
	add	a,Sprites@Widths & 255
	ld	l,a
	adc	a,Sprites@Widths >> 8
	sub	l
	ld	h,a
	ld	a,[hl]
	add	a,b
	ld	b,a
	pop	de
	jr	@PutChar
;;;;;

@LabelsFixupMore:
	ex	af,af'
	add	a,4
	ex	af,af'
@LabelsFixup:
	ex	af,af'
	exx
	ld	b,0
	ld	c,a
	add	hl,bc
	exx
	jp	@LabelsLoop

@LabelsDone:
	ld	a,[save7]
	out	[7],a

	ld	hl,saveSScreen
	ld	de,saveSScreen + 1
	ld	bc,11
	push	bc
	ld	[hl],$FF
	ldir
	ex	de,hl
	pop	de
	push	de
	ld	b,62
@SidebarsLoop:
	set	7,[hl]
	add	hl,de
	set	0,[hl]
	inc	hl
	djnz	@SidebarsLoop
	ld	de,saveSScreen + 757
	pop	bc
	ld	[hl],$FF
	ldir
	bcall	_RstrOScreen
	ret

@ClipGroup:
	exx
	ld	a,l
	add	a,b
	ld	l,a
	adc	a,h
	sub	l
	ld	h,a
	jp	@CheckHL

@GetCoordinates:
	LOAD_BYTE
	ld	e,a
	LOAD_BYTE
	ld	d,a
	ld	hl,[currLon]
	add	hl,de
	ld	[prevLon],hl
	ex	de,hl
	ld	bc,[zoom]
	call	MultBCxDEx2
	push	de
	LOAD_BYTE
	ld	e,a
	LOAD_BYTE
	ld	d,a
	ld	hl,[currLat]
	add	hl,de
	ld	[prevLat],hl
	ex	de,hl
	ld	bc,[zoom]
	call	MultBCxDEx2
	pop	hl
	ret

@CohenSutherland:
	ld	bc,128
	add	hl,bc
	ex	de,hl
	add	hl,bc
	ex	de,hl
	ld	a,h
	or	d
	ld	a,$FF
	ret	nz
@CohenSutherland@Partial:
	ld	a,e
	cp	97
	rl	b
	add	a,255-158
	rl	b
	ld	a,l
	cp	81
	rl	b
	add	a,255-174
	rl	b
	ld	a,b
	ret

DrawLine@GetCSCode:
	ld	b,0
	ld	a,e
	cp	97
	rl	b
	add	a,255-158
	rl	b
	ld	a,d
	cp	81
	rl	b
	add	a,255-174
	rl	b
	ld	a,b
function(DrawLine):
	exx
	ld	a,b
	exx
	and	b
	ret	nz
	cp	b
	jr	nz,@NoSwitch
	exx
	cp	b
	jr	nz,@NoSwitch

	ld	a,d
	sub	80
	exx
	ld	h,a
	exx
	ld	a,159
	sub	e
	exx
	ld	l,a
	ld	a,d
	sub	80
	ld	d,a
	ld	a,159
	sub	e
	ld	e,a

	ld	a,[save7]
	out	[7],a
	jp	Line
@NoSwitch:
	rrc	b
	jr	nc,@NotRight
	ld	a,d
	sub	174
	ld	h,a
	exx
	ld	a,e
	exx
	sub	e
	jr	c,@RightNeg
	ld	c,a
	call	MultHxC
	ld	a,d
	exx
	sub	d
	ret	z
	exx
	ld	c,a
	call	DivHLbyC
	ld	a,e
	add	a,l
	jr	@RightPos
@RightNeg:
	neg
	ld	c,a
	call	MultHxC
	ld	a,d
	exx
	sub	d
	ret	z
	exx
	ld	c,a
	call	DivHLbyC
	ld	a,e
	sub	l
@RightPos:
	ld	e,a
	ld	d,174
	jp	DrawLine@GetCSCode
@NotRight:
	rrc	b
	jr	nc,@NotLeft
	ld	a,81
	sub	d
	ld	h,a
	exx
	ld	a,e
	exx
	sub	e
	jr	c,@LeftNeg
	ld	c,a
	call	MultHxC
	exx
	ld	a,d
	exx
	sub	d
	ret	z
	ld	c,a
	call	DivHLbyC
	ld	a,e
	add	a,l
	jr	@LeftPos
@LeftNeg:
	neg
	ld	c,a
	call	MultHxC
	exx
	ld	a,d
	exx
	sub	d
	ret	z
	ld	c,a
	call	DivHLbyC
	ld	a,e
	sub	l
@LeftPos:
	ld	e,a
	ld	d,81
	jp	DrawLine@GetCSCode
@NotLeft:
	rrc	b
	jr	nc,@NotBottom
	ld	a,e
	sub	158
	ld	h,a
	exx
	ld	a,d
	exx
	sub	d
	jr	c,@BottomNeg
	ld	c,a
	call	MultHxC
	ld	a,e
	exx
	sub	e
	ret	z
	exx
	ld	c,a
	call	DivHLbyC
	ld	a,d
	add	a,l
	jr	@BottomPos
@BottomNeg:
	neg
	ld	c,a
	call	MultHxC
	ld	a,e
	exx
	sub	e
	ret	z
	exx
	ld	c,a
	call	DivHLbyC
	ld	a,d
	sub	l
@BottomPos:
	ld	d,a
	ld	e,158
	jp	DrawLine@GetCSCode
@NotBottom:
	ld	a,97
	sub	e
	ld	h,a
	exx
	ld	a,d
	exx
	sub	d
	jr	c,@TopNeg
	ld	c,a
	call	MultHxC
	exx
	ld	a,e
	exx
	sub	e
	ret	z
	ld	c,a
	call	DivHLbyC
	ld	a,d
	add	a,l
	jr	@TopPos
@TopNeg:
	neg
	ld	c,a
	call	MultHxC
	exx
	ld	a,e
	exx
	sub	e
	ret	z
	ld	c,a
	call	DivHLbyC
	ld	a,d
	sub	l
@TopPos:
	ld	d,a
	ld	e,97
	jp	DrawLine@GetCSCode

function(SetZoomLevel):
	ld	[zoomLevel],a
	ld	l,a
	add	a,a
	add	a,a
	add	a,l
	add	a,OurWorld@Zooms & 255
	ld	l,a
	adc	a,OurWorld@Zooms >> 8
	sub	l
	ld	h,a
	ld	e,[hl]
	inc	hl
	ld	d,[hl]
	inc	hl
	ld	[zoom],de
	ld	e,[hl]
	inc	hl
	ld	d,[hl]
	inc	hl
	ld	[zoomZ],de
	ld	a,[hl]
	ld	[zoomSkip],a
	ret

function(NameCopy):
@Loop:
	ld	a,[hl]
	inc	hl
	cp	32
	jr	c,@Compressed
	cp	96
	jr	nc,@Compressed
	ld	[de],a
	inc	de
	djnz	@Loop
	xor	a
	ld	[de],a
	ret
@Compressed:
	push	hl
	push	de
	sub	96
	ld	h,0
	ld	l,a
	add	hl,hl
	ld	de,Strings@ngrams
	add	hl,de
	pop	de
	ld	c,2
	ldi
	ldi
	pop	hl
	djnz	@Loop
	xor	a
	ld	[de],a
	ret

function(PutLabel):
	ld	a,[de]
	inc	de
	or	a
	ret	z
	call	@ConvChar
	call	@PutChar
	jr	PutLabel
@PutChar:
	jr	c,@Space
	push	af
	push	ix
	pop	hl
	ld	c,a
	add	a,a
	add	a,c
	add	a,a
	add	a,c
	ld	b,0
	ld	c,a
	add	hl,bc
	add	hl,bc
	ld	bc,[penCol]
	call	PutSprite
	pop	af
@Space:
	add	a,Sprites@Widths & 255
	ld	l,a
	adc	a,Sprites@Widths >> 8
	sub	l
	ld	h,a
	ld	c,[hl]
	ld	a,[penRow]	; really the column.. hehe
	add	a,c
	ld	[penRow],a
	ret
@ConvChar:
	cp	$27
	ret	c
	sub	$27
	ret	z
	sub	5
	jr	z,@ConvCharComma
	cp	3
	ccf
	ret	nc
	sub	$12
	ret
@ConvCharComma:
	ld	a,29
	ret
