function(HelpScreen):
	ld	hl,appBackupScreen
	bcall	_SaveDisp
@NoSave:
	ld	a,$FF
	ld	hl,saveSScreen
	ld	de,saveSScreen + 1
	ld	bc,(7 * 12) - 1
	push	bc
	ld	[hl],a
	ldir
	inc	hl
	inc	de
	ld	[hl],b
	ld	bc,(50 * 12) - 1
	ldir
	inc	hl
	inc	de
	pop	bc
	ld	[hl],a
	ldir
	bcall	_RstrOScreen

	set	textInverse,[iy + textFlags]
	xor	a
	ld	[penRow],a
	ld	hl,Strings@Title
	call	VPutsCenter
	ld	a,$39
	ld	[penRow],a
	ld	hl,Strings@Email
	call	VPutsCenter
	res	textInverse,[iy + textFlags]

	ld	hl,Strings@Help
; inputs: HL -> message (first byte is line count)
function(MessageBox):
	ld	b,[hl]
	inc	hl
	push	hl
	push	bc
	ld	a,b
	add	a,a
	add	a,b
	add	a,a
	add	a,8
	ld	c,a
	ld	b,5
	push	bc
	call	DialogBox
	bcall	_RstrOScreen
	pop	de
	pop	bc
	pop	hl
	ld	a,64 - 2
	sub	e
	srl	a
@Loop:
	ld	[penRow],a
	push	bc
	call	VPutsCenter
	pop	bc
	ld	a,[penRow]
	add	a,6
	djnz	@Loop
	add	a,3
	ld	[penRow],a
	ld	hl,Strings@AnyKey
	call	VPutsCenter
	call	GetKey
RestoreScreen:
	ld	b,64
	ld	hl,appBackupScreen
	bcall	_RestoreDisp
	ret

InvertOptionsMenu:
	ld	c,16
	jr	InvertMenu
InvertMainMenu:
	ld	c,8
InvertMenu:
	ld	a,[menu]
	add	a,a
	add	a,a
	add	a,a
	add	a,c
	ld	c,a
	ld	b,4
	ld	de,(5 * 256) + 7
;B,C coordinates; D,E size
function(InvertBar):
	bcall	_SaveOScreen
	push	de
	ld	hl,saveSScreen
	ld	a,c
	add	a,a
	add	a,a
	ld	d,0
	ld	e,a
	add	hl,de
	add	hl,de
	add	hl,de
	ld	e,b
	add	hl,de
	pop	de
@RowLoop:
	push	de
	push	hl
@ColLoop:
	ld	a,[hl]
	cpl
	ld	[hl],a
	inc	hl
	dec	d
	jr	nz,@ColLoop
	pop	hl
	ld	de,12
	add	hl,de
	pop	de
	dec	e
	jr	nz,@RowLoop
	bcall	_RstrOScreen
	ret

function(MainMenu):
	ld	hl,appBackupScreen
	bcall	_SaveDisp
	ld	b,3
	ld	c,47
	call	DialogBox
	ld	hl,saveSScreen + (8 * 12) + 3
	ld	de,@Bitmaps
	ld	c,6
@BitmapLoop:
	call	@BitmapCommon
	jr	nz,@BitmapLoop

	bcall	_RstrOScreen

	ld	b,6
	ld	hl,@Strings
	ld	a,8
@StringLoop:
	ld	[penRow],a
	ld	a,34
	ld	[penCol],a
	push	bc
	call	VPutsApp
	pop	bc
	ld	a,[penRow]
	add	a,8
	djnz	@StringLoop

	call	InvertMainMenu

@Keys:
	call	GetKey
	cp	kUp
	jr	nz,@NotUp
	call	InvertMainMenu
	ld	a,[menu]
	sub	1
	jr	nc,@UpOkay
	ld	a,5
@UpOkay:
	ld	[menu],a
	call	InvertMainMenu
	jr	@Keys
@NotUp:
	cp	kDown
	jr	nz,@NotDown
	call	InvertMainMenu
	ld	a,[menu]
	inc	a
	cp	6
	jr	c,@UpOkay
	xor	a
	jr	@UpOkay
@NotDown:
	cp	kClear
	jp	z,RestoreScreen
	cp	kEnter
	jr	nz,@Keys
	call	RestoreScreen
	ld	a,[menu]
	dec	a
	jp	z,OptionsMenu
	dec	a
	jp	z,LocationSensor
	dec	a
	jp	z,Distance
	dec	a
	jp	z,Search
	dec	a
	jp	z,ForceExit
	jp	HelpScreen@NoSave

@BitmapCommon:
	ld	b,7
@BitmapLine:
	ld	a,[de]
	inc	de
	ld	[hl],a
	push	de
	ld	de,12
	add	hl,de
	pop	de
	djnz	@BitmapLine
	push	de
	ld	de,12
	add	hl,de
	pop	de
	dec	c
	ret

@Strings:
.db "Help",0
.db "Options",0
.db "Sensor",0
.db "Distance",0
.db "Search",0
.db "Quit",0

@Bitmaps:
.db %00111100
.db %01100110
.db %00001100
.db %00011000
.db %00011000
.db %00000000
.db %00011000

.db %00000000
.db %10111110
.db %00000000
.db %10111110
.db %00000000
.db %10111110
.db %00000000

.db %00010000
.db %00111000
.db %01010100
.db %11111110
.db %01010100
.db %00111000
.db %00010000

.db %00000110
.db %00000110
.db %00001000
.db %00010000
.db %00100000
.db %11000000
.db %11000000

.db %01110000
.db %10001000
.db %10001000
.db %10001000
.db %01111100
.db %00001110
.db %00000110

.db %01111110
.db %01001110
.db %01000010
.db %01001010
.db %01000010
.db %01110010
.db %00001110

function(OptionsMenu):
	ld	hl,appBackupScreen
	bcall	_SaveDisp
	ld	a,[options]
	xor	3
	ld	[menu],a
	ld	b,3
	ld	c,31
	call	DialogBox
	ld	hl,saveSScreen + (16 * 12) + 3
	ld	c,4
@BitmapLoop:
	ld	de,@BitmapOff
	ld	a,[options]
	inc	a
	cp	c
	jr	nz,@NotSelected
	ld	de,@BitmapOn
@NotSelected:
	call	MainMenu@BitmapCommon
	jr	nz,@BitmapLoop

	bcall	_RstrOScreen

	ld	b,4
	ld	hl,@Strings
	ld	a,16
@StringLoop:
	ld	[penRow],a
	ld	a,34
	ld	[penCol],a
	push	bc
	call	VPutsApp
	pop	bc
	ld	a,[penRow]
	add	a,8
	djnz	@StringLoop

	call	InvertOptionsMenu

@Keys:
	call	GetKey
	cp	kUp
	jr	nz,@NotUp
	call	InvertOptionsMenu
	ld	a,[menu]
	sub	1
	jr	nc,@UpOkay
	ld	a,3
@UpOkay:
	ld	[menu],a
	call	InvertOptionsMenu
	jr	@Keys
@NotUp:
	cp	kDown
	jr	nz,@NotDown
	call	InvertOptionsMenu
	ld	a,[menu]
	inc	a
	cp	4
	jr	c,@UpOkay
	xor	a
	jr	@UpOkay
@NotDown:
	cp	kClear
	jp	z,RestoreScreen
	cp	kEnter
	jr	nz,@Keys
	call	RestoreScreen
	ld	a,[menu]
	xor	3
	ld	[options],a
	ld	a,1
	ld	[menu],a
	scf
	ret

@Strings:
.db "No Labels",0
.db "Regions",0
.db "& Capitals",0
.db "Everything",0

@BitmapOff:
.db %00111000
.db %01000100
.db %10000010
.db %10000010
.db %10000010
.db %01000100
.db %00111000

@BitmapOn:
.db %00111000
.db %01000100
.db %10111010
.db %10111010
.db %10111010
.db %01000100
.db %00111000

function(VPutsApp):
	ld	de,Buffer
@Loop:
	ld	a,[hl]
	ld	[de],a
	inc	hl
	inc	de
	or	a
	jr	nz,@Loop
@Done:
	push	hl
	ld	hl,Buffer
	bcall	_VPutS
	pop	hl
	ret

function(VPutsCenter):
	ld	b,0
	ld	de,Buffer + 1
@Loop:
	ld	a,[hl]
	ld	[de],a
	inc	hl
	inc	de
	or	a
	jr	z,@Done
	inc	b
	jr	@Loop
@Done:
	push	hl
	ld	hl,Buffer
	ld	[hl],b
	bcall	_SStringLength
	inc	hl
	ld	a,48
	srl	b
	sub	b
	ld	[penCol],a
	bcall	_VPutS
	pop	hl
DummyRet:
	ret

; inputs: B = X size (/16), C = Y size
function(DialogBox):
	bcall	_SaveOScreen

	ld	a,5
	add	a,c
	ld	c,a
	ld	a,64 - 5
	sub	c
	srl	a
	add	a,a
	add	a,a
	ld	d,0
	ld	e,a
	ld	hl,saveSScreen
	add	hl,de
	add	hl,de
	add	hl,de

	push	hl
	ld	de,%1111000000000000
	xor	a
	call	@Horiz
	and	%00001111
	ld	[hl],a
	pop	hl
	ld	de,12
	add	hl,de

	push	de
	push	hl
	ld	de,%1110000000000111
	ld	a,$FF
	call	@Horiz
	and	%00000111
	or	%11100000
	ld	[hl],a
	pop	hl
	pop	de
	add	hl,de

	push	de
	push	hl
	ld	de,%1110000000001000
	xor	a
	call	@Horiz
	and	%00000011
	or	%00010000
	ld	[hl],a
	pop	hl
	pop	de
	add	hl,de

@Loop:
	push	de
	push	hl
	ld	de,%1110000000001000
	xor	a
	call	@Horiz
	and	%00000011
	or	%00011000
	ld	[hl],a
	pop	hl
	pop	de
	add	hl,de
	dec	c
	jr	nz,@Loop

	push	de
	push	hl
	ld	de,%1110000000000111
	ld	a,$FF
	call	@Horiz
	and	%00000011
	or	%11111000
	ld	[hl],a
	pop	hl
	pop	de
	add	hl,de

	push	de
	push	hl
	ld	de,%1111000000000011
	ld	a,$FF
	call	@Horiz
	and	%00000011
	or	%11110000
	ld	[hl],a
	pop	hl
	pop	de
	add	hl,de

	ld	de,%1111100000000000
	xor	a
	call	@Horiz
	and	%00000111
	ld	[hl],a
	ret

@Horiz:
	push	af
	dec	hl
	ld	a,6
	sub	b
@HorizFind:
	inc	hl
	dec	a
	jr	nz,@HorizFind
	ld	a,[hl]
	and	d
	or	e
	ld	[hl],a
	inc	hl
	pop	af
	ld	d,b
	sla	d
@HorizLoop:
	ld	[hl],a
	inc	hl
	dec	d
	jr	nz,@HorizLoop
	ld	a,[hl]
	ret

function(LocationSensor):
	ld	ix,Buffer + 1
	ld	de,[currLat]
	call	@ConvertDegrees
	ld	[ix],'S'
	jr	z,@NotNorth
	ld	[ix],'N'
@NotNorth:
	inc	ix
	ld	[ix],0
	inc	ix

	ld	de,[currLon]
	call	@ConvertDegrees
	ld	[ix],'W'
	jr	z,@NotEast
	ld	[ix],'E'
@NotEast:
	inc	ix
	ld	[ix],0
	inc	ix

	ld	hl,Buffer
	ld	[hl],2
	jp	MessageBox

@ConvertDegrees:
	ld	bc,675
	call	MultBCxDE
	ld	a,h
	sra	d
	rr	e
	rra
	sra	d
	rr	e
	rra
	sra	d
	rr	e
	rra
	ld	h,e
	ld	l,a
	bit	7,h
	jr	z,@NotNeg
	cpl
	ld	l,a
	ld	a,h
	cpl
	ld	h,a
	inc	hl
@NotNeg:
	push	af
	ld	c,60
	call	DivHLbyC
	push	af
	ld	a,l
	call	@ConvA
	ld	[ix],$D4
	inc	ix
	pop	af
	call	@ConvA
	ld	[ix],$27
	inc	ix
	pop	af
	ret
@ConvA:
	cp	100
	jr	c,@ConvA_1
	sub	100
	ld	[ix],'1'
	inc	ix
	jr	@ConvA_4
@ConvA_1:
	cp	10
	jr	c,@ConvA_3
@ConvA_4:
	ld	e,'0' - 1
@ConvA_2:
	inc	e
	sub	10
	jr	nc,@ConvA_2
	add	a,10
	ld	[ix],e
	inc	ix
@ConvA_3:
	add	a,'0'
	ld	[ix],a
	inc	ix
	ret

function(Distance):
	ld	hl,[city1Sel]
	ld	a,[city1Sel + 2]
	call	FindLabel
	ld	[city1Sel],hl
	ld	[city1Sel + 2],a
	ret	c
	ld	[City1X],bc
	ld	[City1Y],de
	add	ix,ix
	jr	nc,@City1Okay
	ld	hl,Strings@CitiesOnly
	call	MessageBox
	jr	Distance
@City1Okay:
	ld	hl,[city2Sel]
	ld	a,[city2Sel + 2]
	call	FindLabel
	ld	[city2Sel],hl
	ld	[city2Sel + 2],a
	ret	c
	ld	[City2X],bc
	ld	[City2Y],de
	add	ix,ix
	jr	nc,@City2Okay
	ld	hl,Strings@CitiesOnly
	call	MessageBox
	jr	@City1Okay
@City2Okay:
	ld	a,[city1sel + 2]
	ld	bc,[city2sel + 2]
	cp	c
	jr	nz,@CityXNotSame
	ld	hl,[city1sel]
	ld	de,[city2sel]
	sbc	hl,de
	jr	nz,@cityXNotSame
	ld	hl,Strings@SameCities
	call	MessageBox
	jr	Distance
@CityXNotSame:

	ld	hl,[City1Y]
	call	@SetXXXXOP2
	ld	hl,Numbers@ConvRadians
	rst	20h	;_Mov9ToOP1
	bcall	_FPMult
	bcall	_OP1ToOP5
	ld	hl,[City2Y]
	call	@SetXXXXOP2
	ld	hl,Numbers@ConvRadians
	rst	20h	;_Mov9ToOP1
	bcall	_FPMult
	bcall	_OP1ToOP6
	bcall	_OP5ToOP2
	rst	30h	;_FPAdd
	bcall	_TimesPt5
	rst	18h	;_PushRealO1
	bcall	_OP5ToOP1
	bcall	_OP6ToOP2
	bcall	_FPSub
	bcall	_TimesPt5
	bcall	_SinCosRad
	ld	de,MathSinG
	call	Mov18FrOP1
	bcall	_PopRealO1
	bcall	_SinCosRad
	ld	de,MathSinF
	call	Mov18FrOP1

	ld	hl,[City1X]
	call	@SetXXXXOP2
	ld	hl,Numbers@ConvRadians
	rst	20h	;_Mov9ToOP1
	bcall	_FPMult
	bcall	_OP1ToOP5
	ld	hl,[City2X]
	call	@SetXXXXOP2
	ld	hl,Numbers@ConvRadians
	rst	20h	;_Mov9ToOP1
	bcall	_FPMult
	bcall	_OP5ToOP2
	bcall	_OP1ExOP2
	bcall	_FPSub
	bcall	_TimesPt5
	bcall	_SinCosRad
	ld	de,MathSinLam
	call	Mov18FrOP1

	ld	hl,MathCosG
	rst	20h	;_Mov9ToOP1
	ld	hl,MathCosLam
	bcall	_Mov9ToOP2
	bcall	_FPMult
	bcall	_FPSquare
	rst	18h	;_PushRealO1
	ld	hl,MathSinF
	rst	20h	;_Mov9ToOP1
	ld	hl,MathSinLam
	bcall	_Mov9ToOP2
	bcall	_FPMult
	bcall	_FPSquare
	bcall	_PopRealO2
	rst	30h	;_FPAdd
	ld	de,MathC
	bcall	_MovFrOP1

	ld	hl,MathSinG
	rst	20h	;_Mov9ToOP1
	ld	hl,MathCosLam
	bcall	_Mov9ToOP2
	bcall	_FPMult
	bcall	_FPSquare
	rst	18h	;_PushRealO1
	ld	hl,MathCosF
	rst	20h	;_Mov9ToOP1
	ld	hl,MathSinLam
	bcall	_Mov9ToOP2
	bcall	_FPMult
	bcall	_FPSquare
	bcall	_PopRealO2
	rst	30h	;_FPAdd
	ld	de,MathS
	bcall	_MovFrOP1

	ld	hl,MathC
	bcall	_Mov9ToOP2
	bcall	_FPDiv
	bcall	_SqRoot
	bcall	_ATanRad
	ld	de,MathOmega
	bcall _MovFrOP1

	ld	hl,MathS
	rst	20h	;_Mov9ToOP1
	ld	hl,MathC
	bcall	_Mov9ToOP2
	bcall	_FPMult
	bcall	_SqRoot
	ld	hl,MathOmega
	bcall	_Mov9ToOP2
	bcall	_FPDiv
	ld	de,MathR
	bcall	_MovFrOP1

	bcall	_OP2Set3
	bcall	_FPMult
	bcall	_Plus1
	bcall	_TimesPt5
	ld	hl,MathS
	bcall	_Mov9ToOP2
	bcall	_FPDiv
	rst	18h	;_PushRealO1
	ld	hl,MathCosF
	rst	20h	;_Mov9ToOP1
	ld	hl,MathSinG
	bcall	_Mov9ToOP2
	bcall	_FPMult
	bcall	_FPSquare
	bcall	_PopRealO2
	bcall	_FPMult
	rst	18h	;_PushRealO1
	ld	hl,MathR
	rst	20h	;_Mov9ToOP1l
	bcall	_OP2Set3
	bcall	_FPMult
	bcall	_Minus1
	bcall	_TimesPt5
	ld	hl,MathC
	bcall	_Mov9ToOP2
	bcall	_FPDiv
	rst	18h	;_PushRealO1
	ld	hl,MathSinF
	rst	20h	;_Mov9ToOP1
	ld	hl,MathCosG
	bcall	_Mov9ToOP2
	bcall	_FPMult
	bcall	_FPSquare
	bcall	_PopRealO2
	bcall	_FPMult
	bcall	_PopRealO2
	bcall	_FPSub
	ld	hl,Numbers@SquashFactor
	bcall	_Mov9ToOP2
	bcall	_FPMult
	bcall	_Plus1
	ld	hl,Numbers@EarthRadius
	bcall	_Mov9ToOP2
	bcall	_FPMult
	ld	hl,MathOmega
	bcall	_Mov9ToOP2
	bcall	_FPMult
	bcall	_Times2
	ld	de,MathKilos
	bcall	_MovFrOP1
	ld	hl,Numbers@ConvMiles
	bcall	_Mov9ToOP2
	bcall	_FPMult
	ld	de,MathMiles
	bcall	_MovFrOP1

	ld	hl,Strings@Distance
	ld	de,Buffer
	push	de
	call	StrCpy
	push	de
	ld	hl,MathMiles
	rst	20h	;_Mov9ToOP1
	bcall	_Int
	ld	a,6
	bcall	_FormEReal
	ld	hl,OP3
	pop	de
	call	StrCpy
	dec	de
	ld	hl,Strings@DistanceMiles
	call	StrCpy
	push	de
	ld	hl,MathKilos
	rst	20h	;_Mov9ToOP1
	bcall	_Int
	ld	a,6
	bcall	_FormEReal
	ld	hl,OP3
	pop	de
	call	StrCpy
	dec	de
	ld	hl,Strings@DistanceKilos
	call	StrCpy

	ld	hl,appBackupScreen
	bcall	_SaveDisp
	pop	hl
	jp	MessageBox

@SetXXXXOP2:
	bit	7,h
	jr	nz,@SetXXXXOP2Neg
	bcall	_SetXXXXOP2
	ret
@SetXXXXOP2Neg:
	ld	a,h
	cpl
	ld	h,a
	ld	a,l
	cpl
	ld	l,a
	inc	hl
	bcall	_SetXXXXOP2
	bcall	_InvOP2S
	ret

function(Search):
	ld	hl,[findSel]
	ld	a,[findSel + 2]
	call	FindLabel
	ld	[findSel],hl
	ld	[findSel + 2],a
	ret	c
	ld	hl,0
	push	hl
	or	a
	sbc	hl,bc
	ld	[currLon],hl
	pop	hl
	or	a
	sbc	hl,de
	ld	[currLat],hl
	push	ix
	pop	af
	and	31
	cp	31
	jr	nz,@NotAmerica
	ld	a,1
@NotAmerica:
	call	SetZoomLevel
	scf
	ret

function(FindLabel):
	ld	[curSel],a
	ld	a,h
	or	l
	jr	nz,@RunBefore
	ld	hl,$8000 + (OurWorld@LabelData & $3FFF)
@RunBefore:
	ld	[topSel],hl

	ld	hl,appBackupScreen
	bcall	_SaveDisp

	set	shiftKeepAlph,[iy + shiftFlags]
	set	shiftAlpha,   [iy + shiftFlags]

	in	a,[7]
	ld	[save7],a
@Redraw:
	di
	ld	a,[save7]
	out	[7],a

	ld	b,4
	ld	c,42
	call	DialogBox
	ld	hl,(16 * 256) + 11
	ld	[penCol],hl
	ld	ix,Sprites@Horiz
	ld	a,80-7
	ld	[clipx],a

	ld	hl,[topSel]
@Shown:
	in	a,[6]
	sub	5
	out	[7],a
	ld	a,[hl]
	inc	hl
	and	31
	ld	b,a
	ld	a,[hl]
	ld	de,5
	add	hl,de
	add	a,a
	jr	c,@NotCity
	add	a,a
	ld	a,[save7]
	out	[7],a
	ld	a,15	; 30 / 2
	adc	a,a
	push	bc
	push	hl
	call	PutLabel@PutChar
	in	a,[6]
	sub	5
	out	[7],a
	pop	hl
	pop	bc
@NotCity:
	ld	de,Buffer
	push	de
	call	NameCopy
	pop	de
	push	hl
	ld	a,[save7]
	out	[7],a
	call	PutLabel
	ld	hl,[penCol]
	ld	h,16
	ld	a,l
	add	a,7
	ld	l,a
	ld	[penCol],hl
	cp	53
	pop	hl
	jr	c,@Shown

	bcall	_RstrOScreen
	ld	a,[curSel]
	ld	c,a
	add	a,a
	add	a,c
	add	a,a
	add	a,c
	add	a,11
	ld	c,a
	ld	b,2
	ld	de,(8 * 256) + 7
	call	InvertBar

@Keys:
	call	GetKey
	cp	kUp
	jr	nz,@NotUp
	ld	a,[curSel]
	or	a
	call	z,@MoveListUp
	dec	a
	ld	[curSel],a
	jp	@Redraw
@NotUp:
	cp	kDown
	jr	nz,@NotDown
	ld	a,[curSel]
	cp	5
	call	nc,@MoveListDown
	inc	a
	ld	[curSel],a
	jp	@Redraw
@NotDown:
	cp	kClear
	jr	z,@Cancel
	cp	kEnter
	jp	z,@Select
	sub	kCapA
	cp	kCapZ - kCapA + 1
	jr	nc,@Keys
	add	a,'A'
	cp	'X'
	jr	nz,@NotX
	ld	a,'Y'
@NotX:
	ld	c,a

	di
	in	a,[6]
	sub	5
	out	[7],a

	ld	hl,[topSel]
	ld	a,[curSel]
	ld	b,a
	inc	b
	ld	d,0
@SkipByLetter1:
	ld	a,[hl]
	and	31
	add	a,6
	ld	e,a
	add	hl,de
	djnz	@SkipByLetter1

	jr	@SkipByLetter2
@SkipByLetter3:
	ld	hl,$8000 + (OurWorld@LabelData & $3FFF)
@SkipByLetter2:
	ld	d,h
	ld	e,l
	ld	a,[hl]
	inc	hl
	and	31
	jr	z,@SkipByLetter3
	ld	b,a
	ld	a,[hl]
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	add	a,a
	jr	nc,@IsCity
	push	bc
	push	de
	ld	de,Buffer
	call	NameCopy
	pop	de
	pop	bc
	ld	a,[Buffer]
	cp	c
	jr	z,@SkipByLetterDone
	jr	nc,@SkipByLetter3
	jr	@SkipByLetter2
@IsCity:
	ld	d,0
	ld	e,b
	add	hl,de
	jr	@SkipByLetter2
@SkipByLetterDone:
	ld	hl,$8000 + (OurWorld@LabelData@LastAllowed & $3FFF)
	xor	a
	sbc	hl,de
	jr	nc,@SkipByLetterOkay
	ld	de,$8000 + (OurWorld@LabelData@LastAllowed & $3FFF)
	ld	a,3
@SkipByLetterOkay:
	ld	[topSel],de
	ld	[curSel],a
	jp	@Redraw

@Cancel:
	res	shiftKeepAlph,[iy + shiftFlags]
	res	shiftAlpha,   [iy + shiftFlags]
	res	indicInUse,   [iy + indicFlags]
	call	RestoreScreen
	ld	hl,[topSel]
	ld	a,[curSel]
	scf

	ret

@Select:
	in	a,[6]
	sub	5
	out	[7],a
	ld	hl,[topSel]
	ld	a,[curSel]
	ld	b,a
@GetSel:
	ld	a,[hl]
	inc	hl
	and	31
	add	a,4
	ld	e,a
	ld	a,[hl]
	inc	hl
	ld	d,a
	ld	a,b
	or	a
	jr	z,@GetSelDone
	ld	d,0
	add	hl,de
	dec	b
	jr	@GetSel
@GetSelDone:
	push	de
	pop	ix
	ld	b,[hl]
	inc	hl
	ld	c,[hl]
	inc	hl
	ld	d,[hl]
	inc	hl
	ld	e,[hl]

	ld	a,[save7]
	out	[7],a

	res	shiftKeepAlph,[iy + shiftFlags]
	res	shiftAlpha,   [iy + shiftFlags]
	res	indicInUse,   [iy + indicFlags]

	push	bc
	push	de
	call	RestoreScreen
	pop	de
	pop	bc
	ld	hl,[topSel]
	ld	a,[curSel]
	or	a

	ret

@MoveListUp:
	ld	hl,[topSel]
	ld	de,$8000 + (OurWorld@LabelData & $3FFF)
	or	a
	sbc	hl,de
	jr	z,@MoveListUpBottom

	di
	in	a,[6]
	sub	5
	out	[7],a

	ld	de,$8000 + (OurWorld@LabelData & $3FFF)
@MoveListUpLoop:
	ld	b,d
	ld	c,e
	ld	a,[de]
	and	31
	add	a,6
	ld	h,0
	ld	l,a
	add	hl,de
	ex	de,hl
	ld	hl,[topSel]
	or	a
	sbc	hl,de
	jr	nz,@MoveListUpLoop
	ld	[topSel],bc
	ld	a,1
	ret

@MoveListUpBottom:
	ld	hl,$8000 + (OurWorld@LabelData@LastAllowed & $3FFF)
	ld	[topSel],hl
	ld	a,5 + 1
	ret

@MoveListDown:
	ld	de,[topSel]
	ld	hl,$8000 + (OurWorld@LabelData@LastAllowed & $3FFF)
	or	a
	sbc	hl,de
	jr	z,@MoveListDownTop
	ex	de,hl

	di
	in	a,[6]
	sub	5
	out	[7],a

	ld	a,[hl]
	and	31
	ld	de,6
	add	hl,de
	ld	e,a
	add	hl,de
	ld	[topSel],hl
	ld	a,4
	ret
@MoveListDownTop:
	ld	hl,$8000 + (OurWorld@LabelData & $3FFF)
	ld	[topSel],hl
	ld	a,$FF
	ret
