#define  APP_NAME "OurWorld"
#define  APP_PAGES 6
#define  FAST_SE
#include "app.inc"

_RstrOScreen	equ	45F7h
_SaveOScreen	equ	45FAh

prevLon	= $FE70 + 0
prevLat	= $FE70 + 2
prevX		= $FE70 + 4
prevY		= $FE70 + 6
prevCohen	= $FE70 + 8
currX		= $FE70 + 9
currY		= $FE70 + 11
currCohen	= $FE70 + 13
zoom		= $FE70 + 14
zoomZ		= $FE70 + 16
zoomSkip	= $FE70 + 18
save7		= $FE70 + 19
Buffer	= $FE70 + 20
topSel	= $FE70 + 84
curSel	= $FE70 + 86
;
options	= $FE70 + 87
findSel	= $FE70 + 88
city1Sel	= $FE70 + 91
city2Sel	= $FE70 + 94
zoomLevel	= $FE70 + 97
currLon	= $FE70 + 98
currLat	= $FE70 + 100
; 102
EndOfUsage	= $FE70 + 128

function(Init):
	ld	hl,-EndOfUsage
	add	hl,sp
	jr	c,@StackOkay
	bjump	_ErrMemory
@StackOkay:

	bcall	_RunIndicOff
	bcall	_ClrLCDFull
	
	ld	hl,AppVectors
	bcall	_AppInit
	ld	hl,LineBegin
	ld	de,Line
	ld	bc,LineSize
	ldir
	ld	a,4
	ld	[menu],a
	
@TryFindAgain:
	ld	hl,Strings@VarName
	rst	20h
	bcall	_ChkFindSym
	jr	nc,@Found
	ld	hl,15
	bcall	_CreateAppVar
	inc	de
	inc	de
	push	de
	ld	h,d
	ld	l,e
	inc	de
	ld	bc,14
	ld	[hl],b
	ldir
	pop	hl
	scf
	jr	@Created
@Found:
	inc	b
	dec	b
	jr	z,@NotArchived
	bcall	_Arc_Unarc
	jr	@TryFindAgain
@NotArchived:
	ex	de,hl
	inc	hl
	inc	hl
	or	a
@Created:
	ld	[appVarPtr],hl
	ld	de,options
	ld	bc,15
	ldir
	call	c,HelpScreen
	ld	a,[zoomLevel]
	call	SetZoomLevel
	
function(MainLoop):
	call	DrawGlobe	
@NoChange:
	call	GetKey
	cp	kClear
	jr	nz,@NotClear
	call	MainMenu
	jr	nc,@NoChange
	jr	MainLoop
@NotClear:
	cp	kAdd
	jr	nz,@NotPlus
	ld	a,[zoomLevel]
	cp	ZOOM_COUNT - 1
	jr	nc,@NoChange
	inc	a
	call	SetZoomLevel
	jr	MainLoop
@NotPlus:
	cp	kSub
	jr	nz,@NotMinus
	ld	a,[zoomLevel]
	or	a
	jr	z,@NoChange
	dec	a
	call	SetZoomLevel
	jr	MainLoop
@NotMinus:
	cp	kLeft
	jr	nz,@NotLeft
	ld	hl,[currLon]
	ld	de,[zoomZ]
	add	hl,de
	ld	[currLon],hl
	jr	MainLoop
@NotLeft:
	cp	kRight
	jr	nz,@NotRight
	ld	hl,[currLon]
	ld	de,[zoomZ]
	sbc	hl,de
	ld	[currLon],hl
	jr	MainLoop
@NotRight:
	cp	kDown
	jr	nz,@NotDown
	ld	hl,[currLat]
	ld	de,[zoomZ]
	add	hl,de
	ld	a,h
	add	a,$40
	jp	p,@DownOkay
	ld	hl,16384
@DownOkay:
	ld	[currLat],hl
	jr	MainLoop
@NotDown:	
	cp	kUp
	jr	nz,@NotUp
	ld	hl,[currLat]
	ld	de,[zoomZ]
	sbc	hl,de
	ld	a,h
	add	a,$40
	jp	p,@UpOkay
	ld	hl,-16384
@UpOkay:
	ld	[currLat],hl
	jp	MainLoop
@NotUp:
	jp	MainLoop@NoChange

ForceExit:
	res	monAbandon,[iy + monFlags]
function(AppPutAway):
	ld	hl,options
	ld	de,[appVarPtr]
	ld	bc,15
	ldir

	bcall	_ReloadAppEntryVecs
	res	shiftKeepAlph,[iy + shiftFlags]
	res	shiftAlpha,   [iy + shiftFlags]
	bit	monAbandon,[iy + monFlags]
	jr	nz,@Off
	ld	a,iall
	out	[intrptEnPort],a
	bcall	_LCD_DRIVERON
	set	onRunning,[iy + onFlags]
	ei
	bcall	_JForceCmdNoChar
@Off	bjump	_Putaway

#include "core.asm"
#include "menus.asm"
#include "helper.asm"
#include "data.asm"

appVarPtr	= Line + LineSize
menu		= Line + LineSize + 2
rows2put	= Line + LineSize + 3
clipmask	= Line + LineSize + 4
clipx		= Line + LineSize + 5
City1X	= Line + LineSize + 6
City1Y	= Line + LineSize + 8
City2X	= Line + LineSize + 10
City2Y	= Line + LineSize + 12
; 14

MathSinF	= appBackupScreen
MathCosF	= appBackupScreen + 9
MathSinG	= appBackupScreen + 18
MathCosG	= appBackupScreen + 27
MathSinLam	= appBackupScreen + 36
MathCosLam	= appBackupScreen + 45
MathS		= appBackupScreen + 54
MathC		= appBackupScreen + 63
MathOmega	= appBackupScreen + 72
MathR		= appBackupScreen + 81
MathKilos	= appBackupScreen + 90
MathMiles	= appBackupScreen + 99

.end
